Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/UserService.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/UserService.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/UserService.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,86 @@
+package internettehnologii.imaps.backendRender.web.service;
+
+import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
+import internettehnologii.imaps.backendRender.web.repo.UserRepository;
+import jakarta.transaction.Transactional;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.authentication.AuthenticationManager;
+import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
+import org.springframework.security.core.Authentication;
+import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+import java.util.Objects;
+import java.util.Optional;
+
+@Service
+public class UserService {
+
+    @Autowired
+    private final UserRepository userRepository;
+
+    private final BCryptPasswordEncoder bCryptPasswordEncoder = new BCryptPasswordEncoder(12);
+    @Autowired
+    private JWTService jwtService;
+
+    @Autowired
+    private AuthenticationManager authenticationManager;
+
+    @Autowired
+    public UserService(UserRepository userRepository){
+        this.userRepository = userRepository;
+    }
+
+    public List<IMapsUser> getUsers(){
+        return userRepository.findAll();
+    }
+
+    public IMapsUser register(IMapsUser user) {
+        Optional<IMapsUser> usrOptional = userRepository.findUserByEmail(user.getEmail());
+        if(usrOptional.isPresent()){
+            throw new IllegalStateException("email taken");
+        }
+
+        user.setPassword(bCryptPasswordEncoder.encode(user.getPassword()));
+        return userRepository.save(user);
+    }
+
+    public void deleteUser(Long userId) {
+        boolean exists = userRepository.existsById(userId);
+        if(!exists){
+            throw new IllegalStateException("User with id: " + userId + " does not exist");
+        }
+        userRepository.deleteById(userId);
+    }
+
+    @Transactional
+    public void updateUser(Long userId, String name, String email) {
+        IMapsUser user = userRepository.findById(userId).orElseThrow(() -> new IllegalStateException("user with id " + userId + " does not exist"));
+        if(name != null && !name.isEmpty() && !Objects.equals(user.getUsername(), name)){
+            user.setUsername(name);
+        }
+
+        if(email != null && !email.isEmpty() && !Objects.equals(user.getEmail(), email)){
+            Optional<IMapsUser> userOptional = userRepository.findUserByEmail(email);
+            if(userOptional.isPresent()){
+                throw new IllegalStateException("email taken");
+            }
+
+            user.setEmail(email);
+        }
+    }
+
+    public String verify(IMapsUser user) {
+        Authentication authentication =
+                authenticationManager.authenticate(
+                        new UsernamePasswordAuthenticationToken(user.getUsername(), user.getPassword()));
+
+        if(authentication.isAuthenticated()){
+            return jwtService.generateToken(user.getUsername());
+        }
+
+        return "Auth failed";
+    }
+
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/util/StringListConverter.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/util/StringListConverter.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/util/StringListConverter.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,34 @@
+package internettehnologii.imaps.backendRender.web.util;
+
+import jakarta.persistence.AttributeConverter;
+import jakarta.persistence.Converter;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import java.io.IOException;
+import java.util.List;
+
+@Converter
+public class StringListConverter implements AttributeConverter<List<String>, String> {
+
+    private final ObjectMapper objectMapper = new ObjectMapper();
+
+
+    @Override
+    public String convertToDatabaseColumn(List<String> attribute) { //LIST<STRING> TO JSON(STRING)
+        try {
+            return objectMapper.writeValueAsString(attribute);
+        } catch (JsonProcessingException e) {
+            throw new RuntimeException("Could not convert list to JSON", e);
+        }
+    }
+
+    @Override
+    public List<String> convertToEntityAttribute(String dbData) { //JSON(STRING) TO LIST<STRING>
+        try {
+            return objectMapper.readValue(dbData, List.class);
+        } catch (IOException e) {
+            throw new RuntimeException("Could not convert JSON to list", e);
+        }
+    }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/util/UserPrincipal.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/util/UserPrincipal.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/util/UserPrincipal.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -3,5 +3,4 @@
 import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
 import org.springframework.security.core.GrantedAuthority;
-import org.springframework.security.core.authority.SimpleGrantedAuthority;
 import org.springframework.security.core.userdetails.UserDetails;
 
@@ -17,5 +16,5 @@
     @Override
     public Collection<? extends GrantedAuthority> getAuthorities() {
-        return user.getRoles().stream().map(r -> new SimpleGrantedAuthority("ROLE_" + r.getName())).toList();
+        return List.of();
     }
 
Index: imaps-backend/backendRender/src/test/java/internettehnologii/imaps/backendRender/RouteGraphTest.java
===================================================================
--- imaps-backend/backendRender/src/test/java/internettehnologii/imaps/backendRender/RouteGraphTest.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/test/java/internettehnologii/imaps/backendRender/RouteGraphTest.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,40 @@
+package internettehnologii.imaps.backendRender;
+
+import internettehnologii.imaps.backendRender.graph.Coordinates;
+import internettehnologii.imaps.backendRender.graph.MapNode;
+import internettehnologii.imaps.backendRender.graph.RouteGraph;
+import org.junit.jupiter.api.Test;
+import org.junit.jupiter.api.BeforeEach;
+
+import java.util.*;
+import java.util.List;
+
+import static org.assertj.core.api.AssertionsForInterfaceTypes.assertThat;
+
+class RouteGraphTest {
+
+    private RouteGraph routeGraph;
+
+    @BeforeEach
+    void setUp() {
+        MapNode nodeA = new MapNode("A", new Coordinates<>(0.0, 0.0), Arrays.asList("B"));
+        MapNode nodeB = new MapNode("B", new Coordinates<>(5.0, 7.0), Arrays.asList("A","C","D"));
+        MapNode nodeC = new MapNode("C", new Coordinates<>(9.0, 7.0), Arrays.asList("B","D"));
+        MapNode nodeD = new MapNode("D", new Coordinates<>(9.0, 12.0), Arrays.asList("B","C"));
+
+        List<MapNode> nodes = Arrays.asList(nodeA, nodeB, nodeC,nodeD);
+        routeGraph = new RouteGraph(nodes);
+    }
+
+    @Test
+    void testFindRouteBetweenConnectedNodes() {
+        List<MapNode> path = routeGraph.findRoute("D", "A");
+        for (MapNode node : path) {
+            System.out.print(
+                    node.getName() + " ---> "
+            );
+        }
+        assertThat(path).isNotEmpty();
+        //assertThat(path).extracting(MapNode::getName).containsExactly("A", "B", "C");
+    }
+}
